.wrapper {
    font-family: inherit;
    font-size: inherit;
    display: flex;
    flex-direction: column;
    position: relative;
    color: $color-input-placeholder;
    cursor: pointer;

    .icon {
    }

    &:hover:not(.disabled):not(.error),
    &:active:not(.disabled):not(.error),
    &:focus:not(.disabled):not(.error),
    &.focus:not(.disabled):not(.error) {
        color: $color-input-focus;
    }

    &.disabled {
        color: $color-input-disabled;

        & * {
            cursor: not-allowed;
        }
    }

    &.error {
        color: $color-input-error;
    }

    &.readonly {
        color: $color-input-readonly;

        & * {
            cursor: default;
        }
    }

    input {
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        cursor: inherit;
        margin: 0;
        opacity: 0;
        padding: 0;
        z-index: 1;
        position: absolute;
    }

    &.label-position {
        display: flex;
        flex-wrap: nowrap;

        &.top {
            flex-direction: column;
            align-items: center;
        }

        &.left {
            flex-direction: row;
            justify-content: flex-end;
            align-items: center;
            @include marginBottom(6);
        }

        &.right {
            flex-direction: row;
            justify-content: flex-start;
            align-items: center;
        }

        &.form-left {
            flex-direction: row;
            justify-content: space-between;
            align-items: flex-start;
            @include marginBottom(6);

            .label {
                display: flex;
                flex-wrap: nowrap;
                align-items: center;
                flex: 30%;
                color: $color-base;
                min-height: $line-height * 1em;
                @include padding(2, 3, 2, 0);
            }

            .mark {
                color: $color-input-error;
                @include marginLeft(1);
            }

            .helper {
                @include marginLeft(2);
            }

            .placeholder {
                flex-grow: 1;
                flex-basis: 70%;
                line-height: 2.2em;
            }
        }
    }

    .label {
        color: inherit;
        min-height: $line-height * 1em;
        @include padding(2, 3);

        .mark {
            color: $color-input-error;
            @include marginLeft(1);
            @include marginRight(1);
        }
    }

    .error {
        font-size: $font-size-base;
        color: $color-input-error;
        line-height: 1.2;
        min-height: 1.2em;

        @include marginTop(1);
    }
}
